#include "loc.h"
#include <logger.h>
#include <stdarg.h>
#include <stdio.h>

#define ERROR_PFX "\x1b[1;31merror\x1b[0m"
#define WARN_PFX "\x1b[1;33mwarn\x1b[0m"
#define INFO_PFX "\x1b[1;32minfo\x1b[0m"
#define DEBUG_PFX "\x1b[1;34mdebug\x1b[0m"

void _log(loc_t* loc, log_level_t level, const char* fmt, ...) {
    va_list args;
    va_start(args, fmt);
    if (loc) {
        printf("%s:%d:%d ", loc->file, loc->line, loc->col);
    }
    switch (level) { // clang-format off
    case (ERROR): printf(ERROR_PFX); break;
    case (WARN): printf(WARN_PFX); break;
    case (INFO): printf(INFO_PFX); break;
    case (DEBUG): printf(DEBUG_PFX); break;
    } // clang-format on
    printf(": ");
    vprintf(fmt, args);
    printf("\n");
    va_end(args);
}
