#include "argparse.h"
#include "logger.h"
#include "parser/ast.h"
#include "parser/parser.h"
#include "dynarray.h"
#include "prettyprint.h"
#include "token.h"
#include <util.h>
#include <tokeniser.h>
#include <stdio.h>
#include <compiler.h>

int main(int argc, const char** argv) {
    args_t* args = parse_args(argc, argv);
    if (!args) {
        return 1;
    }

    char* str = read_to_string(args->input_files[0]);
    token_t* tokens = tokenise_string((char*)args->input_files[0], str);
    int token_count = dynarray_length(tokens);

    for (int i = 0; i < token_count; i++) {
        break;
        token_t tok = tokens[i];
        switch (tok.type) {
        case (TT_KW): {
            printf("TOK: KW %s\n", KW_LIST[tok.kw_type]);
        } break;
        case (TT_OP): {
            printf("TOK: OP %s\n", OP_LIST[tok.op_type]);
        } break;
        case (TT_IDENT): {
            printf("TOK: IDENT \"%s\"\n", tok.str_v);
        } break;
        case (TT_PUSH_INT): {
            printf("TOK: PUSH_INT \"%zu\"\n", tok.int_v);
        } break;
        case (TT_PUSH_STR): {
            printf("TOK: PUSH_STR \"%s\"\n", tok.str_v);
        } break;
        default:
            break;
        }
    }
    program_t* ast = parse(tokens);
    pretty_print(tokens);
    compile(args, ast);
    return 0;
}
